# Python Utility Functions

This repository contains a collection of utility functions written in Python for various common tasks.

## Functions Included:

### `print_list(list, parse_by_str)`
Prints a list with elements separated by a specified string.

### `list_to_str(list, parse_by_str)`
Converts a list to a string with elements separated by a specified string.

### `delete_all_from_list(lst, item)`
Removes all occurrences of a specific item from a list.

### `num_len(num)`
Calculates the length of a number (removing non-digit characters).

### `flatten_list(lst)`
Flattens a nested list into a single list.

### `item_getter(list, key)`
Retrieves values from a list of dictionaries based on specified keys.

### `transpose(matrix)`
Transposes a matrix (list of lists).

### `retry(func, attempts=3, delay=1, exceptions=(Exception,))`
Retries a function multiple times with a delay in case of exceptions.

### `make_unique(lst)`
Removes duplicates while preserving the original order of elements.

### `make_unique_keep_idx(lst)`
Removes duplicates from a list and replaces duplicate elements with an empty string.

### `merge_dicts(dict1, dict2)`
Merges two dictionaries into a single dictionary.

### `print_dict(dict, parse_by_str)`
Prints a dictionary with values separated by a specified string.

### `dict_to_list(dict)`
Converts dictionary values into a list.

### `dict_to_str(dict, parse_by_str)`
Converts dictionary values to a string with elements separated by a specified string.

---

Feel free to use these functions in your projects or extend them further as needed!